<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Import VB Users</title>
</head>

<body>
<!---
The purpose of this script will import users from a vBulletin user table into an exisiting user database.
Obviously back things up first!
Author: Phil Williams www.openmindedsolutions.co.uk
Revision: v1.0 15th May 2008
vBulletin Version: 3.7.0
--->
<!---datasource connection for existing database--->
<cfparam name="newdsn" default="vbullnew">
<!---datasource connection for old users table--->
<cfparam name="olddsn" default="vbullold">

<!---
To combat the problem of duplicate usernames we add a default string to append to the imported username.
This will mean if the email address does not exist in the existing forum but the username does, the imported
username will be edited to avoid a conflict
--->
<cfparam name="usernamesuffix" default="_yoursuffix">

<!---for this import we will be inserting the new users into their own group, just enter the groupid below.  You can also just add them to the registered users group--->
<cfparam name="newusergroupid" default="12">

<!---default user title.  This can be anything you like really--->
<cfparam name="newusertitle" default="I'm new, hello">

<!---default options numeric (this will vary from forum to forum)--->
<cfparam name="newoptions" default="7383">

<!---default language id--->
<cfparam name="newlanguageid" default="0">

<!---default date value if you don't want members possibly joining in the past.  Just use the last users date--->
<cfparam name="defdate" default="1210862231">

<!---grab all the data from the old users table--->
<cfquery datasource="#olddsn#" name="getoldusers">
	SELECT *
	FROM user
</cfquery>

<!---just a simple counter so we know how many inserts there were--->
<cfset usercount=1>
<!---loop over the users--->
<cfoutput query="getoldusers">
	<!---check for existence of user by the email address and skip it if it already exists--->
	<cfquery datasource="#newdsn#" name="emailchk">
		SELECT email
		FROM user
		WHERE email=<cfqueryparam value="#email#" cfsqltype="cf_sql_varchar">
	</cfquery>
	<cfif emailchk.recordcount EQ 0>
		<!---check for username conflicts--->
		<cfquery datasource="#newdsn#" name="usrchk">
			SELECT username
			FROM user
			WHERE username=<cfqueryparam value="#username#" cfsqltype="cf_sql_varchar">
		</cfquery>
		<cfif usrchk.recordcount EQ 0>
			<cfset newusername=username>
		<cfelse>
			<cfset newusername=username & usernamesuffix>
		</cfif>
		<!---new user so insert them into the users table--->
		<cfquery datasource="#newdsn#">
			INSERT INTO user
				(
					usergroupid,
					displaygroupid,
					username,
					password,
					passworddate,
					email,
					homepage,
					icq,
					aim,
					yahoo,
					msn,
					skype,
					showvbcode,
					usertitle,
					joindate,
					lastvisit,
					lastactivity,
					timezoneoffset,
					pmpopup,
					options,
					ipaddress,
					languageid,
					emailstamp,
					threadedmode,
					autosubscribe,
					salt
				)
			VALUE
				(
					<cfqueryparam value="#newusergroupid#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#displaygroupid#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#newusername#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#password#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#passworddate#" cfsqltype="cf_sql_date">,
					<cfqueryparam value="#email#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#homepage#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#icq#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#aim#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#yahoo#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#msn#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#skype#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#showvbcode#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#newusertitle#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#defdate#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#defdate#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#defdate#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#timezoneoffset#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#pmpopup#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#newoptions#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#ipaddress#" cfsqltype="cf_sql_varchar">,
					<cfqueryparam value="#newlanguageid#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#emailstamp#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#threadedmode#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#autosubscribe#" cfsqltype="cf_sql_integer">,
					<cfqueryparam value="#salt#" cfsqltype="cf_sql_varchar">
				)
		</cfquery>
		<!---find out the new userid--->
		<cfquery datasource="#newdsn#" name="getnew">
			SELECT MAX(userid) AS lastid
			FROM user
		</cfquery>
		<cfset newuserid=getnew.lastid>
		<!---insert into the userfield table--->
		<cfquery datasource="#newdsn#">
			INSERT INTO userfield
				(
					userid
				)
			VALUES
				(
					<cfqueryparam value="#newuserid#" cfsqltype="cf_sql_integer">
				)
		</cfquery>
		<!---insert into the usertextfield table--->
		<cfquery datasource="#newdsn#">
			INSERT INTO usertextfield
				(
					userid
				)
			VALUES
				(
					<cfqueryparam value="#newuserid#" cfsqltype="cf_sql_integer">
				)
		</cfquery>
		<cfset usercount=usercount+1>
	</cfif>
</cfoutput>
All done!  Inserted <cfoutput>#usercount#</cfoutput> new users.
</body>
</html>
